export declare type CacheRecord<T, K extends string | number> = Record<K, {
    lastFetchTimestamp: number;
    value?: T;
} | undefined>;
export declare class CachedDataContainer<T, K extends any[]> {
    readonly valueGetterFn: (...args: K) => Promise<T | undefined>;
    readonly valueSetterFn?: ((value: T, ...args: K) => Promise<void>) | undefined;
    readonly dataRetentionDurationMs: number;
    private readonly cache;
    private readonly valueProvider;
    constructor(valueGetterFn: (...args: K) => Promise<T | undefined>, valueSetterFn?: ((value: T, ...args: K) => Promise<void>) | undefined, dataRetentionDurationMs?: number);
    getValue(...args: K): Promise<T | undefined>;
    setValue(value: T, ...args: K): Promise<void>;
}
